---
title: CSS Properties and Values API
slug: Web/API/CSS_Properties_and_Values_API
tags:
  - Houdini
---
<p>{{SeeCompatTable}} The <strong>CSS Properties and Values API</strong> — part of the <a href="/en-US/docs/Web/Houdini">CSS Houdini</a> umbrella of APIs — allows developers to explicitly define their {{cssxref('--*', 'CSS custom properties')}}, allowing for property type checking, default values, and properties that do or do not inherit their value.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
	<dt>{{domxref('CSS.registerProperty')}}</dt>
	<dd>Defines how a browser should parse a {{cssxref('--*', 'CSS custom properties')}}. Access this interface through {{domxref('CSS.registerProperty')}} in <a href="/en-US/docs/Web/JavaScript">JavaScript</a>.</dd>
	<dt>{{cssxref('@property')}}</dt>
	<dd>Defines how a browser should parse a {{cssxref('--*', 'CSS custom properties')}}. Access this interface through {{cssxref('@property')}} <a href="/en-US/docs/Web/CSS/At-rule">at-rule</a> in <a href="/en-US/docs/Web/CSS">CSS</a>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following uses {{domxref('CSS.registerProperty')}} in <a href="/en-US/docs/Web/JavaScript">JavaScript</a> to type a {{cssxref('--*', 'CSS custom properties')}}, <code>--my-color</code>, as a color, give it a default value, and not allow it to inherit its value:</p>

<pre class="brush: js notranslate">window.CSS.registerProperty({
  name: '--my-color',
  syntax: '&lt;color&gt;',
  inherits: false,
  initialValue: '#c0ffee',
});
</pre>

<p>The same registration can take place in <a href="/en-US/docs/Web/CSS">CSS</a> using the {{cssxref('@property')}} <a href="/en-US/docs/Web/CSS/At-rule">at-rule</a>:</p>

<pre class="brush: css notranslate">@property --my-color {
  syntax: '&lt;color&gt;';
  inherits: false;
  initial-value: #c0ffee;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('CSS Properties and Values API')}}</td>
			<td>{{Spec2('CSS Properties and Values API')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>See individual interfaces</p>

<h2 id="See_Also">See Also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/CSS_Properties_and_Values_API/guide">Using the CSS properties and values API</a></li>
	<li><a href="/en-US/docs/Web/API/CSS_Painting_API">CSS Painting API</a></li>
	<li><a href="/en-US/docs/Web/API/CSS_Typed_OM_API">CSS Typed Object Model</a></li>
	<li><a href="/en-US/docs/Web/Houdini">CSS Houdini</a></li>
</ul>
